struct _IO_FILE;
typedef struct _IO_FILE FILE;
extern struct _IO_FILE *stdin;
extern struct _IO_FILE *stderr;
void __VERIFIER_assume(int cond) {
    if(!cond) {
        abort();
    }
}

char * read_bytes(char * __inp_var) {
    unsigned int input_length = strlen(__inp_var)-1;
    /* Remove '\n' at end of input */
    if (__inp_var[input_length] == '\n') {
        __inp_var[input_length] = '\0';
    }

    char * parseEnd;
    char * value_pointer = malloc(16);

    unsigned long long intVal = strtoull(__inp_var, &parseEnd, 0);
    if (*parseEnd != 0) {
      long long sintVal = strtoll(__inp_var, &parseEnd, 0);
      if (*parseEnd != 0) {
        long double floatVal = strtold(__inp_var, &parseEnd);
        if (*parseEnd != 0) {
          fprintf(stderr, "Can't parse input: '%s' (failing at '%s')\n", __inp_var, parseEnd);
          abort();

        } else {
          memcpy(value_pointer, &floatVal, 16);
        }
      } else {
        memcpy(value_pointer, &sintVal, 8);
      }
    } else {
      memcpy(value_pointer, &intVal, 8);
    }

    return value_pointer;
}

void __VERIFIER_error() {
    fprintf(stderr, "Error found.\n");
    exit(42);
}

unsigned int access_counter = 0;

char __VERIFIER_nondet_char() {
    unsigned int inp_size = 3000;
    char * inp_var = malloc(inp_size);
    switch(access_counter) {
case 0: strcpy(inp_var, "856789891"); break;
case 1: strcpy(inp_var, "1"); break;
case 2: strcpy(inp_var, "248613675"); break;
case 3: strcpy(inp_var, "3"); break;
case 4: strcpy(inp_var, "2121647297"); break;
case 5: strcpy(inp_var, "1609039059"); break;
case 6: strcpy(inp_var, "1084460094"); break;
case 7: strcpy(inp_var, "0"); break;
case 8: strcpy(inp_var, "408676053"); break;
case 9: strcpy(inp_var, "1770492330"); break;
case 10: strcpy(inp_var, "807274741"); break;
case 11: strcpy(inp_var, "123649458"); break;
case 12: strcpy(inp_var, "1354708530"); break;
case 13: strcpy(inp_var, "1468459427"); break;
case 14: strcpy(inp_var, "1814297737"); break;
case 15: strcpy(inp_var, "5"); break;
case 16: strcpy(inp_var, "1188072035"); break;
case 17: strcpy(inp_var, "1031379719"); break;
case 18: strcpy(inp_var, "1760162239"); break;
case 19: strcpy(inp_var, "133816432"); break;
case 20: strcpy(inp_var, "239342240"); break;
        default: abort();
    }
    access_counter++;
    return *((char *) read_bytes(inp_var));
}

int __VERIFIER_nondet_int() {
    unsigned int inp_size = 3000;
    char * inp_var = malloc(inp_size);
    switch(access_counter) {
case 0: strcpy(inp_var, "856789891"); break;
case 1: strcpy(inp_var, "1"); break;
case 2: strcpy(inp_var, "248613675"); break;
case 3: strcpy(inp_var, "3"); break;
case 4: strcpy(inp_var, "2121647297"); break;
case 5: strcpy(inp_var, "1609039059"); break;
case 6: strcpy(inp_var, "1084460094"); break;
case 7: strcpy(inp_var, "0"); break;
case 8: strcpy(inp_var, "408676053"); break;
case 9: strcpy(inp_var, "1770492330"); break;
case 10: strcpy(inp_var, "807274741"); break;
case 11: strcpy(inp_var, "123649458"); break;
case 12: strcpy(inp_var, "1354708530"); break;
case 13: strcpy(inp_var, "1468459427"); break;
case 14: strcpy(inp_var, "1814297737"); break;
case 15: strcpy(inp_var, "5"); break;
case 16: strcpy(inp_var, "1188072035"); break;
case 17: strcpy(inp_var, "1031379719"); break;
case 18: strcpy(inp_var, "1760162239"); break;
case 19: strcpy(inp_var, "133816432"); break;
case 20: strcpy(inp_var, "239342240"); break;
        default: abort();
    }
    access_counter++;
    return *((int *) read_bytes(inp_var));
}

long __VERIFIER_nondet_long() {
    unsigned int inp_size = 3000;
    char * inp_var = malloc(inp_size);
    switch(access_counter) {
case 0: strcpy(inp_var, "856789891"); break;
case 1: strcpy(inp_var, "1"); break;
case 2: strcpy(inp_var, "248613675"); break;
case 3: strcpy(inp_var, "3"); break;
case 4: strcpy(inp_var, "2121647297"); break;
case 5: strcpy(inp_var, "1609039059"); break;
case 6: strcpy(inp_var, "1084460094"); break;
case 7: strcpy(inp_var, "0"); break;
case 8: strcpy(inp_var, "408676053"); break;
case 9: strcpy(inp_var, "1770492330"); break;
case 10: strcpy(inp_var, "807274741"); break;
case 11: strcpy(inp_var, "123649458"); break;
case 12: strcpy(inp_var, "1354708530"); break;
case 13: strcpy(inp_var, "1468459427"); break;
case 14: strcpy(inp_var, "1814297737"); break;
case 15: strcpy(inp_var, "5"); break;
case 16: strcpy(inp_var, "1188072035"); break;
case 17: strcpy(inp_var, "1031379719"); break;
case 18: strcpy(inp_var, "1760162239"); break;
case 19: strcpy(inp_var, "133816432"); break;
case 20: strcpy(inp_var, "239342240"); break;
        default: abort();
    }
    access_counter++;
    return *((long *) read_bytes(inp_var));
}

void * __VERIFIER_nondet_pointer() {
    unsigned int inp_size = 3000;
    char * inp_var = malloc(inp_size);
    switch(access_counter) {
case 0: strcpy(inp_var, "856789891"); break;
case 1: strcpy(inp_var, "1"); break;
case 2: strcpy(inp_var, "248613675"); break;
case 3: strcpy(inp_var, "3"); break;
case 4: strcpy(inp_var, "2121647297"); break;
case 5: strcpy(inp_var, "1609039059"); break;
case 6: strcpy(inp_var, "1084460094"); break;
case 7: strcpy(inp_var, "0"); break;
case 8: strcpy(inp_var, "408676053"); break;
case 9: strcpy(inp_var, "1770492330"); break;
case 10: strcpy(inp_var, "807274741"); break;
case 11: strcpy(inp_var, "123649458"); break;
case 12: strcpy(inp_var, "1354708530"); break;
case 13: strcpy(inp_var, "1468459427"); break;
case 14: strcpy(inp_var, "1814297737"); break;
case 15: strcpy(inp_var, "5"); break;
case 16: strcpy(inp_var, "1188072035"); break;
case 17: strcpy(inp_var, "1031379719"); break;
case 18: strcpy(inp_var, "1760162239"); break;
case 19: strcpy(inp_var, "133816432"); break;
case 20: strcpy(inp_var, "239342240"); break;
        default: abort();
    }
    access_counter++;
    return *((void * *) read_bytes(inp_var));
}

