struct _IO_FILE;
typedef struct _IO_FILE FILE;
extern struct _IO_FILE *stdin;
extern struct _IO_FILE *stderr;
void __VERIFIER_assume(int cond) {
    if(!cond) {
        abort();
    }
}

char * read_bytes(char * __inp_var) {
    unsigned int input_length = strlen(__inp_var)-1;
    /* Remove '\n' at end of input */
    if (__inp_var[input_length] == '\n') {
        __inp_var[input_length] = '\0';
    }

    char * parseEnd;
    char * value_pointer = malloc(16);

    unsigned long long intVal = strtoull(__inp_var, &parseEnd, 0);
    if (*parseEnd != 0) {
      long long sintVal = strtoll(__inp_var, &parseEnd, 0);
      if (*parseEnd != 0) {
        long double floatVal = strtold(__inp_var, &parseEnd);
        if (*parseEnd != 0) {
          fprintf(stderr, "Can't parse input: '%s' (failing at '%s')\n", __inp_var, parseEnd);
          abort();

        } else {
          memcpy(value_pointer, &floatVal, 16);
        }
      } else {
        memcpy(value_pointer, &sintVal, 8);
      }
    } else {
      memcpy(value_pointer, &intVal, 8);
    }

    return value_pointer;
}

void __VERIFIER_error() {
    fprintf(stderr, "Error found.\n");
    exit(42);
}

unsigned int access_counter = 0;

char __VERIFIER_nondet_char() {
    unsigned int inp_size = 3000;
    char * inp_var = malloc(inp_size);
    switch(access_counter) {
case 0: strcpy(inp_var, "1"); break;
case 1: strcpy(inp_var, "1144948204"); break;
case 2: strcpy(inp_var, "1855476060"); break;
case 3: strcpy(inp_var, "1"); break;
case 4: strcpy(inp_var, "708653011"); break;
case 5: strcpy(inp_var, "1"); break;
case 6: strcpy(inp_var, "587693963"); break;
case 7: strcpy(inp_var, "1417654148"); break;
case 8: strcpy(inp_var, "182498215"); break;
case 9: strcpy(inp_var, "1413514491"); break;
case 10: strcpy(inp_var, "0"); break;
case 11: strcpy(inp_var, "1673497015"); break;
case 12: strcpy(inp_var, "1757234398"); break;
case 13: strcpy(inp_var, "293856493"); break;
case 14: strcpy(inp_var, "236640404"); break;
case 15: strcpy(inp_var, "224249570"); break;
case 16: strcpy(inp_var, "1399647783"); break;
case 17: strcpy(inp_var, "2103529746"); break;
case 18: strcpy(inp_var, "1801542570"); break;
case 19: strcpy(inp_var, "1786047188"); break;
case 20: strcpy(inp_var, "1492208128"); break;
case 21: strcpy(inp_var, "215566116"); break;
case 22: strcpy(inp_var, "1245996920"); break;
case 23: strcpy(inp_var, "2055139470"); break;
case 24: strcpy(inp_var, "350318377"); break;
case 25: strcpy(inp_var, "1396934781"); break;
case 26: strcpy(inp_var, "858105662"); break;
case 27: strcpy(inp_var, "956329285"); break;
case 28: strcpy(inp_var, "1465552170"); break;
case 29: strcpy(inp_var, "481727416"); break;
case 30: strcpy(inp_var, "1818952671"); break;
case 31: strcpy(inp_var, "254342643"); break;
case 32: strcpy(inp_var, "499816867"); break;
case 33: strcpy(inp_var, "987379278"); break;
case 34: strcpy(inp_var, "1337043219"); break;
        default: abort();
    }
    access_counter++;
    return *((char *) read_bytes(inp_var));
}

int __VERIFIER_nondet_int() {
    unsigned int inp_size = 3000;
    char * inp_var = malloc(inp_size);
    switch(access_counter) {
case 0: strcpy(inp_var, "1"); break;
case 1: strcpy(inp_var, "1144948204"); break;
case 2: strcpy(inp_var, "1855476060"); break;
case 3: strcpy(inp_var, "1"); break;
case 4: strcpy(inp_var, "708653011"); break;
case 5: strcpy(inp_var, "1"); break;
case 6: strcpy(inp_var, "587693963"); break;
case 7: strcpy(inp_var, "1417654148"); break;
case 8: strcpy(inp_var, "182498215"); break;
case 9: strcpy(inp_var, "1413514491"); break;
case 10: strcpy(inp_var, "0"); break;
case 11: strcpy(inp_var, "1673497015"); break;
case 12: strcpy(inp_var, "1757234398"); break;
case 13: strcpy(inp_var, "293856493"); break;
case 14: strcpy(inp_var, "236640404"); break;
case 15: strcpy(inp_var, "224249570"); break;
case 16: strcpy(inp_var, "1399647783"); break;
case 17: strcpy(inp_var, "2103529746"); break;
case 18: strcpy(inp_var, "1801542570"); break;
case 19: strcpy(inp_var, "1786047188"); break;
case 20: strcpy(inp_var, "1492208128"); break;
case 21: strcpy(inp_var, "215566116"); break;
case 22: strcpy(inp_var, "1245996920"); break;
case 23: strcpy(inp_var, "2055139470"); break;
case 24: strcpy(inp_var, "350318377"); break;
case 25: strcpy(inp_var, "1396934781"); break;
case 26: strcpy(inp_var, "858105662"); break;
case 27: strcpy(inp_var, "956329285"); break;
case 28: strcpy(inp_var, "1465552170"); break;
case 29: strcpy(inp_var, "481727416"); break;
case 30: strcpy(inp_var, "1818952671"); break;
case 31: strcpy(inp_var, "254342643"); break;
case 32: strcpy(inp_var, "499816867"); break;
case 33: strcpy(inp_var, "987379278"); break;
case 34: strcpy(inp_var, "1337043219"); break;
        default: abort();
    }
    access_counter++;
    return *((int *) read_bytes(inp_var));
}

long __VERIFIER_nondet_long() {
    unsigned int inp_size = 3000;
    char * inp_var = malloc(inp_size);
    switch(access_counter) {
case 0: strcpy(inp_var, "1"); break;
case 1: strcpy(inp_var, "1144948204"); break;
case 2: strcpy(inp_var, "1855476060"); break;
case 3: strcpy(inp_var, "1"); break;
case 4: strcpy(inp_var, "708653011"); break;
case 5: strcpy(inp_var, "1"); break;
case 6: strcpy(inp_var, "587693963"); break;
case 7: strcpy(inp_var, "1417654148"); break;
case 8: strcpy(inp_var, "182498215"); break;
case 9: strcpy(inp_var, "1413514491"); break;
case 10: strcpy(inp_var, "0"); break;
case 11: strcpy(inp_var, "1673497015"); break;
case 12: strcpy(inp_var, "1757234398"); break;
case 13: strcpy(inp_var, "293856493"); break;
case 14: strcpy(inp_var, "236640404"); break;
case 15: strcpy(inp_var, "224249570"); break;
case 16: strcpy(inp_var, "1399647783"); break;
case 17: strcpy(inp_var, "2103529746"); break;
case 18: strcpy(inp_var, "1801542570"); break;
case 19: strcpy(inp_var, "1786047188"); break;
case 20: strcpy(inp_var, "1492208128"); break;
case 21: strcpy(inp_var, "215566116"); break;
case 22: strcpy(inp_var, "1245996920"); break;
case 23: strcpy(inp_var, "2055139470"); break;
case 24: strcpy(inp_var, "350318377"); break;
case 25: strcpy(inp_var, "1396934781"); break;
case 26: strcpy(inp_var, "858105662"); break;
case 27: strcpy(inp_var, "956329285"); break;
case 28: strcpy(inp_var, "1465552170"); break;
case 29: strcpy(inp_var, "481727416"); break;
case 30: strcpy(inp_var, "1818952671"); break;
case 31: strcpy(inp_var, "254342643"); break;
case 32: strcpy(inp_var, "499816867"); break;
case 33: strcpy(inp_var, "987379278"); break;
case 34: strcpy(inp_var, "1337043219"); break;
        default: abort();
    }
    access_counter++;
    return *((long *) read_bytes(inp_var));
}

void * __VERIFIER_nondet_pointer() {
    unsigned int inp_size = 3000;
    char * inp_var = malloc(inp_size);
    switch(access_counter) {
case 0: strcpy(inp_var, "1"); break;
case 1: strcpy(inp_var, "1144948204"); break;
case 2: strcpy(inp_var, "1855476060"); break;
case 3: strcpy(inp_var, "1"); break;
case 4: strcpy(inp_var, "708653011"); break;
case 5: strcpy(inp_var, "1"); break;
case 6: strcpy(inp_var, "587693963"); break;
case 7: strcpy(inp_var, "1417654148"); break;
case 8: strcpy(inp_var, "182498215"); break;
case 9: strcpy(inp_var, "1413514491"); break;
case 10: strcpy(inp_var, "0"); break;
case 11: strcpy(inp_var, "1673497015"); break;
case 12: strcpy(inp_var, "1757234398"); break;
case 13: strcpy(inp_var, "293856493"); break;
case 14: strcpy(inp_var, "236640404"); break;
case 15: strcpy(inp_var, "224249570"); break;
case 16: strcpy(inp_var, "1399647783"); break;
case 17: strcpy(inp_var, "2103529746"); break;
case 18: strcpy(inp_var, "1801542570"); break;
case 19: strcpy(inp_var, "1786047188"); break;
case 20: strcpy(inp_var, "1492208128"); break;
case 21: strcpy(inp_var, "215566116"); break;
case 22: strcpy(inp_var, "1245996920"); break;
case 23: strcpy(inp_var, "2055139470"); break;
case 24: strcpy(inp_var, "350318377"); break;
case 25: strcpy(inp_var, "1396934781"); break;
case 26: strcpy(inp_var, "858105662"); break;
case 27: strcpy(inp_var, "956329285"); break;
case 28: strcpy(inp_var, "1465552170"); break;
case 29: strcpy(inp_var, "481727416"); break;
case 30: strcpy(inp_var, "1818952671"); break;
case 31: strcpy(inp_var, "254342643"); break;
case 32: strcpy(inp_var, "499816867"); break;
case 33: strcpy(inp_var, "987379278"); break;
case 34: strcpy(inp_var, "1337043219"); break;
        default: abort();
    }
    access_counter++;
    return *((void * *) read_bytes(inp_var));
}

