struct _IO_FILE;
typedef struct _IO_FILE FILE;
extern struct _IO_FILE *stdin;
extern struct _IO_FILE *stderr;
void __VERIFIER_assume(int cond) {
    if(!cond) {
        abort();
    }
}

char * read_bytes(char * __inp_var) {
    unsigned int input_length = strlen(__inp_var)-1;
    /* Remove '\n' at end of input */
    if (__inp_var[input_length] == '\n') {
        __inp_var[input_length] = '\0';
    }

    char * parseEnd;
    char * value_pointer = malloc(16);

    unsigned long long intVal = strtoull(__inp_var, &parseEnd, 0);
    if (*parseEnd != 0) {
      long long sintVal = strtoll(__inp_var, &parseEnd, 0);
      if (*parseEnd != 0) {
        long double floatVal = strtold(__inp_var, &parseEnd);
        if (*parseEnd != 0) {
          fprintf(stderr, "Can't parse input: '%s' (failing at '%s')\n", __inp_var, parseEnd);
          abort();

        } else {
          memcpy(value_pointer, &floatVal, 16);
        }
      } else {
        memcpy(value_pointer, &sintVal, 8);
      }
    } else {
      memcpy(value_pointer, &intVal, 8);
    }

    return value_pointer;
}

void __VERIFIER_error() {
    fprintf(stderr, "Error found.\n");
    exit(42);
}

unsigned int access_counter = 0;

char __VERIFIER_nondet_char() {
    unsigned int inp_size = 3000;
    char * inp_var = malloc(inp_size);
    switch(access_counter) {
case 0: strcpy(inp_var, "1"); break;
case 1: strcpy(inp_var, "1570591216"); break;
case 2: strcpy(inp_var, "750317593"); break;
case 3: strcpy(inp_var, "0"); break;
case 4: strcpy(inp_var, "0"); break;
case 5: strcpy(inp_var, "1"); break;
case 6: strcpy(inp_var, "1524197397"); break;
case 7: strcpy(inp_var, "0"); break;
case 8: strcpy(inp_var, "1226766501"); break;
case 9: strcpy(inp_var, "1025266145"); break;
case 10: strcpy(inp_var, "1"); break;
case 11: strcpy(inp_var, "1635789247"); break;
case 12: strcpy(inp_var, "581477536"); break;
case 13: strcpy(inp_var, "523580187"); break;
case 14: strcpy(inp_var, "454451040"); break;
case 15: strcpy(inp_var, "0"); break;
case 16: strcpy(inp_var, "2017442727"); break;
case 17: strcpy(inp_var, "1355254719"); break;
case 18: strcpy(inp_var, "77258415"); break;
case 19: strcpy(inp_var, "2023179723"); break;
case 20: strcpy(inp_var, "369971147"); break;
case 21: strcpy(inp_var, "333390782"); break;
case 22: strcpy(inp_var, "1236657050"); break;
case 23: strcpy(inp_var, "1002201415"); break;
case 24: strcpy(inp_var, "460659475"); break;
case 25: strcpy(inp_var, "647004936"); break;
case 26: strcpy(inp_var, "1574867360"); break;
case 27: strcpy(inp_var, "477454875"); break;
case 28: strcpy(inp_var, "0"); break;
case 29: strcpy(inp_var, "1031293649"); break;
case 30: strcpy(inp_var, "1579982216"); break;
case 31: strcpy(inp_var, "1644351166"); break;
case 32: strcpy(inp_var, "1870904357"); break;
case 33: strcpy(inp_var, "33583684"); break;
case 34: strcpy(inp_var, "289556741"); break;
case 35: strcpy(inp_var, "0"); break;
        default: abort();
    }
    access_counter++;
    return *((char *) read_bytes(inp_var));
}

int __VERIFIER_nondet_int() {
    unsigned int inp_size = 3000;
    char * inp_var = malloc(inp_size);
    switch(access_counter) {
case 0: strcpy(inp_var, "1"); break;
case 1: strcpy(inp_var, "1570591216"); break;
case 2: strcpy(inp_var, "750317593"); break;
case 3: strcpy(inp_var, "0"); break;
case 4: strcpy(inp_var, "0"); break;
case 5: strcpy(inp_var, "1"); break;
case 6: strcpy(inp_var, "1524197397"); break;
case 7: strcpy(inp_var, "0"); break;
case 8: strcpy(inp_var, "1226766501"); break;
case 9: strcpy(inp_var, "1025266145"); break;
case 10: strcpy(inp_var, "1"); break;
case 11: strcpy(inp_var, "1635789247"); break;
case 12: strcpy(inp_var, "581477536"); break;
case 13: strcpy(inp_var, "523580187"); break;
case 14: strcpy(inp_var, "454451040"); break;
case 15: strcpy(inp_var, "0"); break;
case 16: strcpy(inp_var, "2017442727"); break;
case 17: strcpy(inp_var, "1355254719"); break;
case 18: strcpy(inp_var, "77258415"); break;
case 19: strcpy(inp_var, "2023179723"); break;
case 20: strcpy(inp_var, "369971147"); break;
case 21: strcpy(inp_var, "333390782"); break;
case 22: strcpy(inp_var, "1236657050"); break;
case 23: strcpy(inp_var, "1002201415"); break;
case 24: strcpy(inp_var, "460659475"); break;
case 25: strcpy(inp_var, "647004936"); break;
case 26: strcpy(inp_var, "1574867360"); break;
case 27: strcpy(inp_var, "477454875"); break;
case 28: strcpy(inp_var, "0"); break;
case 29: strcpy(inp_var, "1031293649"); break;
case 30: strcpy(inp_var, "1579982216"); break;
case 31: strcpy(inp_var, "1644351166"); break;
case 32: strcpy(inp_var, "1870904357"); break;
case 33: strcpy(inp_var, "33583684"); break;
case 34: strcpy(inp_var, "289556741"); break;
case 35: strcpy(inp_var, "0"); break;
        default: abort();
    }
    access_counter++;
    return *((int *) read_bytes(inp_var));
}

long __VERIFIER_nondet_long() {
    unsigned int inp_size = 3000;
    char * inp_var = malloc(inp_size);
    switch(access_counter) {
case 0: strcpy(inp_var, "1"); break;
case 1: strcpy(inp_var, "1570591216"); break;
case 2: strcpy(inp_var, "750317593"); break;
case 3: strcpy(inp_var, "0"); break;
case 4: strcpy(inp_var, "0"); break;
case 5: strcpy(inp_var, "1"); break;
case 6: strcpy(inp_var, "1524197397"); break;
case 7: strcpy(inp_var, "0"); break;
case 8: strcpy(inp_var, "1226766501"); break;
case 9: strcpy(inp_var, "1025266145"); break;
case 10: strcpy(inp_var, "1"); break;
case 11: strcpy(inp_var, "1635789247"); break;
case 12: strcpy(inp_var, "581477536"); break;
case 13: strcpy(inp_var, "523580187"); break;
case 14: strcpy(inp_var, "454451040"); break;
case 15: strcpy(inp_var, "0"); break;
case 16: strcpy(inp_var, "2017442727"); break;
case 17: strcpy(inp_var, "1355254719"); break;
case 18: strcpy(inp_var, "77258415"); break;
case 19: strcpy(inp_var, "2023179723"); break;
case 20: strcpy(inp_var, "369971147"); break;
case 21: strcpy(inp_var, "333390782"); break;
case 22: strcpy(inp_var, "1236657050"); break;
case 23: strcpy(inp_var, "1002201415"); break;
case 24: strcpy(inp_var, "460659475"); break;
case 25: strcpy(inp_var, "647004936"); break;
case 26: strcpy(inp_var, "1574867360"); break;
case 27: strcpy(inp_var, "477454875"); break;
case 28: strcpy(inp_var, "0"); break;
case 29: strcpy(inp_var, "1031293649"); break;
case 30: strcpy(inp_var, "1579982216"); break;
case 31: strcpy(inp_var, "1644351166"); break;
case 32: strcpy(inp_var, "1870904357"); break;
case 33: strcpy(inp_var, "33583684"); break;
case 34: strcpy(inp_var, "289556741"); break;
case 35: strcpy(inp_var, "0"); break;
        default: abort();
    }
    access_counter++;
    return *((long *) read_bytes(inp_var));
}

void * __VERIFIER_nondet_pointer() {
    unsigned int inp_size = 3000;
    char * inp_var = malloc(inp_size);
    switch(access_counter) {
case 0: strcpy(inp_var, "1"); break;
case 1: strcpy(inp_var, "1570591216"); break;
case 2: strcpy(inp_var, "750317593"); break;
case 3: strcpy(inp_var, "0"); break;
case 4: strcpy(inp_var, "0"); break;
case 5: strcpy(inp_var, "1"); break;
case 6: strcpy(inp_var, "1524197397"); break;
case 7: strcpy(inp_var, "0"); break;
case 8: strcpy(inp_var, "1226766501"); break;
case 9: strcpy(inp_var, "1025266145"); break;
case 10: strcpy(inp_var, "1"); break;
case 11: strcpy(inp_var, "1635789247"); break;
case 12: strcpy(inp_var, "581477536"); break;
case 13: strcpy(inp_var, "523580187"); break;
case 14: strcpy(inp_var, "454451040"); break;
case 15: strcpy(inp_var, "0"); break;
case 16: strcpy(inp_var, "2017442727"); break;
case 17: strcpy(inp_var, "1355254719"); break;
case 18: strcpy(inp_var, "77258415"); break;
case 19: strcpy(inp_var, "2023179723"); break;
case 20: strcpy(inp_var, "369971147"); break;
case 21: strcpy(inp_var, "333390782"); break;
case 22: strcpy(inp_var, "1236657050"); break;
case 23: strcpy(inp_var, "1002201415"); break;
case 24: strcpy(inp_var, "460659475"); break;
case 25: strcpy(inp_var, "647004936"); break;
case 26: strcpy(inp_var, "1574867360"); break;
case 27: strcpy(inp_var, "477454875"); break;
case 28: strcpy(inp_var, "0"); break;
case 29: strcpy(inp_var, "1031293649"); break;
case 30: strcpy(inp_var, "1579982216"); break;
case 31: strcpy(inp_var, "1644351166"); break;
case 32: strcpy(inp_var, "1870904357"); break;
case 33: strcpy(inp_var, "33583684"); break;
case 34: strcpy(inp_var, "289556741"); break;
case 35: strcpy(inp_var, "0"); break;
        default: abort();
    }
    access_counter++;
    return *((void * *) read_bytes(inp_var));
}

