struct _IO_FILE;
typedef struct _IO_FILE FILE;
extern struct _IO_FILE *stdin;
extern struct _IO_FILE *stderr;
void __VERIFIER_assume(int cond) {
    if(!cond) {
        abort();
    }
}

char * read_bytes(char * __inp_var) {
    unsigned int input_length = strlen(__inp_var)-1;
    /* Remove '\n' at end of input */
    if (__inp_var[input_length] == '\n') {
        __inp_var[input_length] = '\0';
    }

    char * parseEnd;
    char * value_pointer = malloc(16);

    unsigned long long intVal = strtoull(__inp_var, &parseEnd, 0);
    if (*parseEnd != 0) {
      long long sintVal = strtoll(__inp_var, &parseEnd, 0);
      if (*parseEnd != 0) {
        long double floatVal = strtold(__inp_var, &parseEnd);
        if (*parseEnd != 0) {
          fprintf(stderr, "Can't parse input: '%s' (failing at '%s')\n", __inp_var, parseEnd);
          abort();

        } else {
          memcpy(value_pointer, &floatVal, 16);
        }
      } else {
        memcpy(value_pointer, &sintVal, 8);
      }
    } else {
      memcpy(value_pointer, &intVal, 8);
    }

    return value_pointer;
}

void __VERIFIER_error() {
    fprintf(stderr, "Error found.\n");
    exit(42);
}

unsigned int access_counter = 0;

char __VERIFIER_nondet_char() {
    unsigned int inp_size = 3000;
    char * inp_var = malloc(inp_size);
    switch(access_counter) {
case 0: strcpy(inp_var, "0"); break;
case 1: strcpy(inp_var, "1014469890"); break;
case 2: strcpy(inp_var, "894630072"); break;
case 3: strcpy(inp_var, "0"); break;
case 4: strcpy(inp_var, "1706186572"); break;
case 5: strcpy(inp_var, "1"); break;
case 6: strcpy(inp_var, "1844006051"); break;
case 7: strcpy(inp_var, "644186042"); break;
case 8: strcpy(inp_var, "0"); break;
case 9: strcpy(inp_var, "1036661172"); break;
case 10: strcpy(inp_var, "412983376"); break;
case 11: strcpy(inp_var, "547949149"); break;
case 12: strcpy(inp_var, "876550060"); break;
case 13: strcpy(inp_var, "916681155"); break;
case 14: strcpy(inp_var, "4265051"); break;
case 15: strcpy(inp_var, "869401070"); break;
case 16: strcpy(inp_var, "1860284405"); break;
case 17: strcpy(inp_var, "2090829932"); break;
case 18: strcpy(inp_var, "2110362582"); break;
case 19: strcpy(inp_var, "1457425216"); break;
case 20: strcpy(inp_var, "625192522"); break;
case 21: strcpy(inp_var, "546471010"); break;
case 22: strcpy(inp_var, "1864565616"); break;
case 23: strcpy(inp_var, "12551390"); break;
case 24: strcpy(inp_var, "1157682722"); break;
case 25: strcpy(inp_var, "916444333"); break;
case 26: strcpy(inp_var, "1"); break;
case 27: strcpy(inp_var, "2064272164"); break;
case 28: strcpy(inp_var, "674765517"); break;
case 29: strcpy(inp_var, "840880722"); break;
case 30: strcpy(inp_var, "1467344003"); break;
case 31: strcpy(inp_var, "1820782159"); break;
case 32: strcpy(inp_var, "1056396594"); break;
case 33: strcpy(inp_var, "1572524543"); break;
case 34: strcpy(inp_var, "249810672"); break;
case 35: strcpy(inp_var, "426615329"); break;
case 36: strcpy(inp_var, "637339134"); break;
case 37: strcpy(inp_var, "847212480"); break;
case 38: strcpy(inp_var, "368433248"); break;
case 39: strcpy(inp_var, "1953067434"); break;
        default: abort();
    }
    access_counter++;
    return *((char *) read_bytes(inp_var));
}

int __VERIFIER_nondet_int() {
    unsigned int inp_size = 3000;
    char * inp_var = malloc(inp_size);
    switch(access_counter) {
case 0: strcpy(inp_var, "0"); break;
case 1: strcpy(inp_var, "1014469890"); break;
case 2: strcpy(inp_var, "894630072"); break;
case 3: strcpy(inp_var, "0"); break;
case 4: strcpy(inp_var, "1706186572"); break;
case 5: strcpy(inp_var, "1"); break;
case 6: strcpy(inp_var, "1844006051"); break;
case 7: strcpy(inp_var, "644186042"); break;
case 8: strcpy(inp_var, "0"); break;
case 9: strcpy(inp_var, "1036661172"); break;
case 10: strcpy(inp_var, "412983376"); break;
case 11: strcpy(inp_var, "547949149"); break;
case 12: strcpy(inp_var, "876550060"); break;
case 13: strcpy(inp_var, "916681155"); break;
case 14: strcpy(inp_var, "4265051"); break;
case 15: strcpy(inp_var, "869401070"); break;
case 16: strcpy(inp_var, "1860284405"); break;
case 17: strcpy(inp_var, "2090829932"); break;
case 18: strcpy(inp_var, "2110362582"); break;
case 19: strcpy(inp_var, "1457425216"); break;
case 20: strcpy(inp_var, "625192522"); break;
case 21: strcpy(inp_var, "546471010"); break;
case 22: strcpy(inp_var, "1864565616"); break;
case 23: strcpy(inp_var, "12551390"); break;
case 24: strcpy(inp_var, "1157682722"); break;
case 25: strcpy(inp_var, "916444333"); break;
case 26: strcpy(inp_var, "1"); break;
case 27: strcpy(inp_var, "2064272164"); break;
case 28: strcpy(inp_var, "674765517"); break;
case 29: strcpy(inp_var, "840880722"); break;
case 30: strcpy(inp_var, "1467344003"); break;
case 31: strcpy(inp_var, "1820782159"); break;
case 32: strcpy(inp_var, "1056396594"); break;
case 33: strcpy(inp_var, "1572524543"); break;
case 34: strcpy(inp_var, "249810672"); break;
case 35: strcpy(inp_var, "426615329"); break;
case 36: strcpy(inp_var, "637339134"); break;
case 37: strcpy(inp_var, "847212480"); break;
case 38: strcpy(inp_var, "368433248"); break;
case 39: strcpy(inp_var, "1953067434"); break;
        default: abort();
    }
    access_counter++;
    return *((int *) read_bytes(inp_var));
}

long __VERIFIER_nondet_long() {
    unsigned int inp_size = 3000;
    char * inp_var = malloc(inp_size);
    switch(access_counter) {
case 0: strcpy(inp_var, "0"); break;
case 1: strcpy(inp_var, "1014469890"); break;
case 2: strcpy(inp_var, "894630072"); break;
case 3: strcpy(inp_var, "0"); break;
case 4: strcpy(inp_var, "1706186572"); break;
case 5: strcpy(inp_var, "1"); break;
case 6: strcpy(inp_var, "1844006051"); break;
case 7: strcpy(inp_var, "644186042"); break;
case 8: strcpy(inp_var, "0"); break;
case 9: strcpy(inp_var, "1036661172"); break;
case 10: strcpy(inp_var, "412983376"); break;
case 11: strcpy(inp_var, "547949149"); break;
case 12: strcpy(inp_var, "876550060"); break;
case 13: strcpy(inp_var, "916681155"); break;
case 14: strcpy(inp_var, "4265051"); break;
case 15: strcpy(inp_var, "869401070"); break;
case 16: strcpy(inp_var, "1860284405"); break;
case 17: strcpy(inp_var, "2090829932"); break;
case 18: strcpy(inp_var, "2110362582"); break;
case 19: strcpy(inp_var, "1457425216"); break;
case 20: strcpy(inp_var, "625192522"); break;
case 21: strcpy(inp_var, "546471010"); break;
case 22: strcpy(inp_var, "1864565616"); break;
case 23: strcpy(inp_var, "12551390"); break;
case 24: strcpy(inp_var, "1157682722"); break;
case 25: strcpy(inp_var, "916444333"); break;
case 26: strcpy(inp_var, "1"); break;
case 27: strcpy(inp_var, "2064272164"); break;
case 28: strcpy(inp_var, "674765517"); break;
case 29: strcpy(inp_var, "840880722"); break;
case 30: strcpy(inp_var, "1467344003"); break;
case 31: strcpy(inp_var, "1820782159"); break;
case 32: strcpy(inp_var, "1056396594"); break;
case 33: strcpy(inp_var, "1572524543"); break;
case 34: strcpy(inp_var, "249810672"); break;
case 35: strcpy(inp_var, "426615329"); break;
case 36: strcpy(inp_var, "637339134"); break;
case 37: strcpy(inp_var, "847212480"); break;
case 38: strcpy(inp_var, "368433248"); break;
case 39: strcpy(inp_var, "1953067434"); break;
        default: abort();
    }
    access_counter++;
    return *((long *) read_bytes(inp_var));
}

void * __VERIFIER_nondet_pointer() {
    unsigned int inp_size = 3000;
    char * inp_var = malloc(inp_size);
    switch(access_counter) {
case 0: strcpy(inp_var, "0"); break;
case 1: strcpy(inp_var, "1014469890"); break;
case 2: strcpy(inp_var, "894630072"); break;
case 3: strcpy(inp_var, "0"); break;
case 4: strcpy(inp_var, "1706186572"); break;
case 5: strcpy(inp_var, "1"); break;
case 6: strcpy(inp_var, "1844006051"); break;
case 7: strcpy(inp_var, "644186042"); break;
case 8: strcpy(inp_var, "0"); break;
case 9: strcpy(inp_var, "1036661172"); break;
case 10: strcpy(inp_var, "412983376"); break;
case 11: strcpy(inp_var, "547949149"); break;
case 12: strcpy(inp_var, "876550060"); break;
case 13: strcpy(inp_var, "916681155"); break;
case 14: strcpy(inp_var, "4265051"); break;
case 15: strcpy(inp_var, "869401070"); break;
case 16: strcpy(inp_var, "1860284405"); break;
case 17: strcpy(inp_var, "2090829932"); break;
case 18: strcpy(inp_var, "2110362582"); break;
case 19: strcpy(inp_var, "1457425216"); break;
case 20: strcpy(inp_var, "625192522"); break;
case 21: strcpy(inp_var, "546471010"); break;
case 22: strcpy(inp_var, "1864565616"); break;
case 23: strcpy(inp_var, "12551390"); break;
case 24: strcpy(inp_var, "1157682722"); break;
case 25: strcpy(inp_var, "916444333"); break;
case 26: strcpy(inp_var, "1"); break;
case 27: strcpy(inp_var, "2064272164"); break;
case 28: strcpy(inp_var, "674765517"); break;
case 29: strcpy(inp_var, "840880722"); break;
case 30: strcpy(inp_var, "1467344003"); break;
case 31: strcpy(inp_var, "1820782159"); break;
case 32: strcpy(inp_var, "1056396594"); break;
case 33: strcpy(inp_var, "1572524543"); break;
case 34: strcpy(inp_var, "249810672"); break;
case 35: strcpy(inp_var, "426615329"); break;
case 36: strcpy(inp_var, "637339134"); break;
case 37: strcpy(inp_var, "847212480"); break;
case 38: strcpy(inp_var, "368433248"); break;
case 39: strcpy(inp_var, "1953067434"); break;
        default: abort();
    }
    access_counter++;
    return *((void * *) read_bytes(inp_var));
}

